Scrum - Defect #1381

Scrum plugin doesn’t work with redmine 3.4.x
2017-07-10 18:07 - Edouard B

Status: Resolved

Priority: Normal

Category: General

Target version: Scrum v0.18.0

Source: Development Blocked: No
Detected on version: Scrum v0.16.2 Alone: No
Description

The scrum plugin work but a lot of pages can't be loaded (error 500) and the log show :

Started GET "/redmine/issues/4299" for x.x.x.x at 2017-07-10 14:30:01 +0200
Processing by IssuesController#show as HTML

Parameters: {"id"=>"4299"}

Current user: xxxxxx (id=1)

Completed 500 Internal Server Error in 47ms (ActiveRecord: 0.0ms)

NoMethodError (undefined method “<<' for {}:Hash

Did you mean? <):

plugins/scrum/lib/scrum/issue_query_patch.rb:47:in “issue_ids_with_scrum'’
app/controllers/issues_controller.rb:423:in “retrieve_previous_and_next_issue_ids'
app/controllers/issues_controller.rb:105:in “block (2 levels) in show'
app/controllers/issues_controller.rb:99:in “show'

lib/redmine/sudo_mode.rb:63:in "'sudo_mode'

Subtasks:

To do # 1392: Upgrade plugin Resolved
To do # 1405: Spent time link on task post-its fails Resolved
To do # 1407: Create and continue button doesn't work Resolved
Related issues:
Has duplicate Scrum - Defect #1393: Cannot save plugin settings Rejected
History
#1 - 2017-07-14 17:03 - Angelinsky7 Angelinsky7
i don't know if this is the right answer but changing the file issue_query_patch.rb
from
def issues_with_scrum(options = {})
options[:include] ||= {}
options[:include] << :sprint
issues_without_scrum(options)
end
alias_method_chain :issues, :scrum
def issue_ids_with_scrum(options = {})
options[:include] |I= {}
options[:include] << :sprint
issue_ids_without_scrum(options)
end
to
def issues_with_scrum(options = {})
options[:include] |I|= T[]
options[:include] << :sprint
issues_without_scrum(options)
end
alias_method_chain :issues, :scrum
def issue_ids_with_scrum(options = {})
options[:include] ||= []

options[:include] << :sprint

issue_ids_without_scrum(options)
end

seems to do the job... i dont know why it was working before the redmine new version because it seems that Hashes in ruby don't have the '<<'
operator but....

#2 - 2017-07-14 17:56 - Angelinsky7 Angelinsky7

to add to the redmine corrections :
in lib\scrum\projects_helper_patch.rb we must change @line 17

index = tabs.index ({:name => 'versions', :action => :manage_versions,
:partial => 'projects/settings/versions',
:label => :label_version_plural})

to

index = tabs.index ({:name => 'versions', :action => :manage_versions,
:partial => 'projects/settings/versions',
:label => :label_version_plural,
:url => {:tab => 'versions',
:version_status => params|[:version_status],
:version_name => params][:version_namel]}})

#3 - 2017-07-18 02:11 - Emilio Gonzalez Montaha

- Target version deleted (Scrum v0.17.0)

#4 - 2017-07-18 02:12 - Emilio Gonzalez Montana
- Status changed from New to In progress

- Target version set to Scrum v0.18.0

#5 - 2017-07-18 02:13 - Emilio Gonzalez Montaina

- Category changed from Issues list & form to General

Plugin settings saving is also affected.

#6 - 2017-07-19 01:42 - Emilio Gonzalez Montana
- Blocked changed from No to Yes

- Alone changed from No to Yes

#7 - 2017-07-19 02:03 - Emilio Gonzalez Montaina
- Sprint set to Sprint 35

Angelinsky7 thanks for the patches.

#8 - 2017-07-19 02:03 - Emilio Gonzalez Montaina
- Blocked changed from Yes to No

#9 - 2017-07-19 02:04 - Emilio Gonzalez Montaina

- Alone changed from Yes to No

#10 - 2017-07-19 02:51 - Emilio Gonzalez Montaiia

- Status changed from In progress to Resolved

#11 - 2017-07-29 11:50 - Emilio Gonzalez Montaiia

- Subject changed from Scrum plugin doesn't work with redmine 3.4.1.0 to Scrum plugin doesn't work with redmine 3.4.x

#12 - 2017-07-30 20:30 - Emilio Gonzalez Montaiia

- Status changed from Resolved to In progress
#13 - 2017-07-30 20:51 - Emilio Gonzalez Montaia

- Status changed from In progress to Resolved

#14 - 2017-07-30 21:15 - Emilio Gonzalez Montaiia

- Status changed from Resolved to In progress

#15 - 2017-07-30 22:05 - Emilio Gonzalez Montaiia

- Status changed from In progress to Resolved

#16 - 2017-09-01 14:06 - Jiirgen Schreier
Angelinsky7 Angelinsky7 escribié:

i don't know if this is the right answer but changing the file issue_query_patch.rb
from

(-]

to

(-]

seems to do the job... i dont know why it was working before the redmine new version because it seems that Hashes in ruby don't have the '<<'
operator but....

Hello Angelinsky?7,

| cannot see any difference in the 2 code blocks that you posted.
Since | do have the same error too | would really like to know what | need to change to make this work

Thanks in advance
Jurgen

PS: just to be clear: | was talking about the changes for the issue_query_patch.rb file.

#17 - 2017-09-06 09:10 - Jiirgen Schreier

After applying the patches from above most of scrum plugin seems to be working.
But | still get the following error 500 when requesting mypage:

Started GET "/my/page" for 212.18.30.153 at 2017-09-06 11:02:31 +0200
Processing by MyController#page as HTML

Current user: js (id=1)

Rendered my/blocks/_timelog.html.erb (2.1ms)

Rendered my/page.html.erb within layouts/base (35.7ms)

Completed 500 Internal Server Error in 72ms (ActiveRecord: 27.3ms)

ActionView::Template::Error (undefined method “<<' for {}:Hash

Did you mean? <):

10: <div id="my-page">

11: <% @groups.each do |group| >

12: <div id="list-<= group >" class="block-receiver">

13: <= render_blocks(@blocks[group], @user) >

14: </div>

15: < end %>

16: </div>

plugins/scrum/lib/scrum/issue_query_patch.rb:40:in “issues_with_scrum’

app/helpers/my_helper.rb:101:in “render_issuesassignedtome_block'

app/helpers/my_helper.rb:64:in “render_block_content'

app/helpers/my_helper.rb:35:in “render_block'

app/helpers/my_helper.rb:27:in “block in render_blocks'

app/helpers/my_helper.rb:26:in “each’

app/helpers/my_helper.rb:26:in “render_blocks'

app/views/my/page.html.erb:13:in “block in app_views_my_page_htmi_erb_1176417024786038216_47278278691620'
app/views/my/page.html.erb:11:in “each’

app/views/my/page.html.erb:11:in *_app_views_my_page_html_erb_ 1176417024786038216_47278278691620'
lib/redmine/sudo_mode.rb:63:in ‘sudo_mode'

line 40(+-) in issue_query_patch.rb file contains this:

def issues_with_scrum(options = {})
options[:include] ||= {}
options[:include] << :sprint
issues_without_scrum(options)
end
alias_method_chain :issues, :scrum

def issue_ids_with_scrum(options = {})
options[:include] |I= {}
options[:include] << :sprint
issue_ids_without_scrum(options)
end
alias_method_chain :issue_ids, :scrum

#18 - 2017-09-20 16:12 - Angelinsky7 Angelinsky7

change with those :

def issues_with_scrum(options = {})
options[:include] ||= []
options[:include] << :sprint
issues_without_scrum(options)
end
alias_method_chain :issues, :scrum

def issue_ids_with_scrum(options = {})
options[:include] ||= []
options[:include] << :sprint
issue_ids_without_scrum(options)

end

alias_method_chain :issue_ids, :scrum

#19 - 2017-09-22 13:31 - Jiirgen Schreier

@Angelinksky: Many thanks that did it. exchanging the {} to [] made it work.

Have a great weekend

Jargen

#20 - 2017-09-28 04:35 - Luan Garrido

I have changed the code like Angelinsky7 Angelinsky7 said, but | still cant update plugin settings.
Right now | cant add any sprint taks or Product Backlog task.

This is my projects_helper_patch.rb file

O7R8M7.png
And that is my issue_query_patch.rb file

qlFxnW.png
Im using redmine version 3.4.2

Which kind of information can | share to be helped?
Thanks =)

#21 - 2017-09-28 19:45 - Emilio Gonzalez Montaiia

A new plugin version will be released in a few weeks, but if any of you want early access my Patreon web (for a 5% tier) offers full access to all my
Redmine plugins GIT repositories.

#22 - 2017-10-16 21:11 - Emilio Gonzalez Montaia

Released.

#23 - 2017-10-16 21:13 - Emilio Gonzalez Montana
- Has duplicate Defect #1393: Cannot save plugin settings added
